/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */


import java.io.IOException;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
 *
 * @author bar
 */
public class CatalogManager extends HttpServlet {
   
    /** 
     * Processes requests for both HTTP <code>GET</code> and <code>POST</code> methods.
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    private PreparedStatement selectStatement = null;
    private PreparedStatement insertStatement = null;

    protected void processRequest(HttpServletRequest request, HttpServletResponse response)
    throws ServletException, IOException {
     
    } 

    // <editor-fold defaultstate="collapsed" desc="HttpServlet methods. Click on the + sign on the left to edit the code.">
    /** 
     * Handles the HTTP <code>GET</code> method.
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doGet(HttpServletRequest request, HttpServletResponse response)
    throws ServletException, IOException {
        processRequest(request, response);
    } 

    /** 
     * Handles the HTTP <code>POST</code> method.
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doPost(HttpServletRequest request, HttpServletResponse response)
    throws ServletException, IOException {
        Connection con = null;
        try {
            Class.forName("org.apache.derby.jdbc.ClientDriver");
            con = DriverManager.getConnection("jdbc:derby://localhost:1527/friends", "test", "test");
            selectStatement = con.prepareStatement("select * from TEST.FRIENDS");
            insertStatement = con.prepareStatement("insert into TEST.FRIENDS values(?,?)");
            List<Map<String,Object>> phones;
            storeData(request.getParameter("name"),request.getParameter("phone"));
            con.commit();
            phones = getData();
            request.setAttribute("friends", phones);
            request.setAttribute("result", "y");
           
        } catch (SQLException ex) {
            Logger.getLogger(CatalogManager.class.getName()).log(Level.SEVERE, "Chyba pri praci s DB.", ex);
        }catch(java.lang.ClassNotFoundException ex1){
            Logger.getLogger(CatalogManager.class.getName()).log(Level.SEVERE,"Chybi ovladac od DB",ex1);
        }finally{
            if(con!=null)
                try {
                insertStatement.close();
                selectStatement.close();
                con.close();
            } catch (SQLException ex) {
                Logger.getLogger(CatalogManager.class.getName()).log(Level.SEVERE, "Nelze uzavrit spojeni: "+con, ex);
            }finally{
                con = null;
                 request.getRequestDispatcher("./result.jsp").forward(request, response);
            }

        }

    }


    /** 
     * Returns a short description of the servlet.
     * @return a String containing servlet description
     */
    @Override
    public String getServletInfo() {
        return "Short description";
    }// </editor-fold>

    private List<Map<String,Object>> getData() throws SQLException {
        List<Map<String,Object>> phones = new ArrayList<Map<String,Object>>();
        ResultSet res = selectStatement.executeQuery();
        while(res.next()){

            String name = res.getString("NAME");
            String phone = res.getString("PHONE");
            Map<String,Object> ph = new HashMap<String,Object>();
            ph.put("name",name);
            ph.put("number", phone);

            phones.add(ph);
        }

        return phones;
    }

    private void storeData(String name, String phone) throws SQLException {
        insertStatement.setString(1, name);
        insertStatement.setString(2, phone);
        insertStatement.executeUpdate();
    }

}
